<center><a href="mpitr.c">Actual source code: mpitr.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:18:59+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSC_DLL</font></strong>
<a name="line2">  2: </a><font color="#B22222">/*</font>
<a name="line3">  3: </a><font color="#B22222">    Code for tracing mistakes in MPI usage. For example, sends that are never received,</font>
<a name="line4">  4: </a><font color="#B22222">  nonblocking messages that are not correctly waited for, etc.</font>
<a name="line5">  5: </a><font color="#B22222">*/</font>

<a name="line7"> 7: </a> #include <A href="../../../include/petsc.h.html">petsc.h</A>

<a name="line9">  9: </a><font color="#A020F0">#if defined(PETSC_USE_LOG) &amp;&amp; !defined(_petsc_mpi_uni)</font>

<a name="line13"> 13: </a><font color="#B22222">/*@C</font>
<a name="line14"> 14: </a><font color="#B22222">   <A href="../../../docs/manualpages/Sys/PetscMPIDump.html#PetscMPIDump">PetscMPIDump</A> - Dumps a listing of incomplete MPI operations, such as sends that</font>
<a name="line15"> 15: </a><font color="#B22222">   have never been received, etc.</font>

<a name="line17"> 17: </a><font color="#B22222">   Collective on <A href="../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A></font>

<a name="line19"> 19: </a><font color="#B22222">   Input Parameter:</font>
<a name="line20"> 20: </a><font color="#B22222">.  fp - file pointer.  If fp is NULL, stdout is assumed.</font>

<a name="line22"> 22: </a><font color="#B22222">   Options Database Key:</font>
<a name="line23"> 23: </a><font color="#B22222">.  -mpidump - Dumps MPI incompleteness during call to <A href="../../../docs/manualpages/Sys/PetscFinalize.html#PetscFinalize">PetscFinalize</A>()</font>

<a name="line25"> 25: </a><font color="#B22222">    Level: developer</font>

<a name="line27"> 27: </a><font color="#B22222">.seealso:  <A href="../../../docs/manualpages/Sys/PetscMallocDump.html#PetscMallocDump">PetscMallocDump</A>()</font>
<a name="line28"> 28: </a><font color="#B22222"> @*/</font>
<a name="line29"> 29: </a><strong><font color="#4169E1"><a name="PetscMPIDump"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../docs/manualpages/Sys/PetscMPIDump.html#PetscMPIDump">PetscMPIDump</A>(FILE *fd)</font></strong>
<a name="line30"> 30: </a>{
<a name="line32"> 32: </a>  <A href="../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A>    <A href="../../../docs/manualpages/Sys/rank.html#rank">rank</A>;
<a name="line33"> 33: </a>  double         tsends,trecvs,work;

<a name="line36"> 36: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_rank.html#MPI_Comm_rank">MPI_Comm_rank</A>(<A href="../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;<A href="../../../docs/manualpages/Sys/rank.html#rank">rank</A>);
<a name="line37"> 37: </a>  <font color="#4169E1">if</font> (!fd) fd = stdout;
<a name="line38"> 38: </a>
<a name="line39"> 39: </a>  <font color="#B22222">/* Did we wait on all the non-blocking sends and receives? */</font>
<a name="line40"> 40: </a>  <A href="../../../docs/manualpages/Sys/PetscSequentialPhaseBegin.html#PetscSequentialPhaseBegin">PetscSequentialPhaseBegin</A>(<A href="../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,1);
<a name="line41"> 41: </a>  <font color="#4169E1">if</font> (irecv_ct + isend_ct != sum_of_waits_ct) {
<a name="line42"> 42: </a>    <A href="../../../docs/manualpages/Sys/PetscFPrintf.html#PetscFPrintf">PetscFPrintf</A>(<A href="../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,fd,<font color="#666666">"[%d]You have not waited on all non-blocking sends and receives"</font>,<A href="../../../docs/manualpages/Sys/rank.html#rank">rank</A>);
<a name="line43"> 43: </a>    <A href="../../../docs/manualpages/Sys/PetscFPrintf.html#PetscFPrintf">PetscFPrintf</A>(<A href="../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,fd,<font color="#666666">"[%d]Number non-blocking sends %g receives %g number of waits %g\n"</font>,<A href="../../../docs/manualpages/Sys/rank.html#rank">rank</A>,isend_ct,irecv_ct,sum_of_waits_ct);
<a name="line44"> 44: </a>    fflush(fd);
<a name="line45"> 45: </a>  }
<a name="line46"> 46: </a>  <A href="../../../docs/manualpages/Sys/PetscSequentialPhaseEnd.html#PetscSequentialPhaseEnd">PetscSequentialPhaseEnd</A>(<A href="../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,1);
<a name="line47"> 47: </a>  <font color="#B22222">/* Did we receive all the messages that we sent? */</font>
<a name="line48"> 48: </a>  work = irecv_ct + recv_ct;
<a name="line49"> 49: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Reduce.html#MPI_Reduce">MPI_Reduce</A>(&amp;work,&amp;trecvs,1,MPI_DOUBLE,MPI_SUM,0,<A href="../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>);
<a name="line50"> 50: </a>  work = isend_ct + send_ct;
<a name="line51"> 51: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Reduce.html#MPI_Reduce">MPI_Reduce</A>(&amp;work,&amp;tsends,1,MPI_DOUBLE,MPI_SUM,0,<A href="../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>);
<a name="line52"> 52: </a>  <font color="#4169E1">if</font> (!<A href="../../../docs/manualpages/Sys/rank.html#rank">rank</A> &amp;&amp; tsends != trecvs) {
<a name="line53"> 53: </a>    <A href="../../../docs/manualpages/Sys/PetscFPrintf.html#PetscFPrintf">PetscFPrintf</A>(<A href="../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,fd,<font color="#666666">"Total number sends %g not equal receives %g\n"</font>,tsends,trecvs);
<a name="line54"> 54: </a>    fflush(fd);
<a name="line55"> 55: </a>  }
<a name="line56"> 56: </a>  <font color="#4169E1">return</font>(0);
<a name="line57"> 57: </a>}

<a name="line59"> 59: </a><font color="#A020F0">#else</font>

<a name="line63"> 63: </a><strong><font color="#4169E1"><a name="PetscMPIDump"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../docs/manualpages/Sys/PetscMPIDump.html#PetscMPIDump">PetscMPIDump</A>(FILE *fd)</font></strong>
<a name="line64"> 64: </a>{
<a name="line66"> 66: </a>  <font color="#4169E1">return</font>(0);
<a name="line67"> 67: </a>}

<a name="line69"> 69: </a><font color="#A020F0">#endif</font>









</pre>
</body>

</html>
